---
title: 'ReferenceError: can''t access lexical declaration`X'' before initialization'
slug: Web/JavaScript/Reference/Errors/Cant_access_lexical_declaration_before_init
tags:
  - Error
  - Errors
  - JavaScript
  - ReferenceError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "can't access lexical declaration `<em>variable</em>' before initialization" occurs when a lexical variable was accessed before it was initialized. This happens within any block statement, when <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code> or <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/const">const</a></code> declarations are accessed before they are defined.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">ReferenceError: Use before delaration (Edge)
ReferenceError: can't access lexical declaration `X' before initialization (Firefox)
ReferenceError: 'x' is not defined (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("ReferenceError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>A lexical variable was accessed before it was initialized. This happens within any block statement, when <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let">let</a></code> or <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/const">const</a></code> declarations are accessed before they are defined.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_cases">Invalid cases</h3>

<p>In this case, the variable "foo" is redeclared in the block statement using <code>let</code>.</p>

<pre class="brush: js example-bad">function test() {
  let foo = 33;
  if (true) {
    let foo = (foo + 55);
    // ReferenceError: can't access lexical
    // declaration `foo' before initialization
  }
}
test();
</pre>

<h3 id="Valid_cases">Valid cases</h3>

<p>To change "foo" inside the if statement, you need to remove the <code>let</code> that causes the redeclaration.</p>

<pre class="brush: js example-good">function test(){
   let foo = 33;
   if (true) {
      foo = (foo + 55);
   }
}
test();
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/let#Temporal_Dead_Zone_and_errors_with_let">Temporal Dead Zone and errors with let</a></li>
</ul>
